on sortListAtoZ aList
  sort(aList)
  set sortedList to EMPTY
  set lastCheck to "A"
  repeat with anItem in aList
    set check to char 1 of anItem
    if check = lastCheck then
      put anItem & RETURN after sortedList
      next repeat
    end if
    put RETURN & anItem & RETURN after sortedList
    set lastCheck to check
  end repeat
  return sortedList
end

on sortFieldAtoZ fieldName
  set aList to stringToList(field fieldName)
  set sortedList to sortListAtoZ(aList)
  put sortedList into field fieldName
end

on recipesAToZ recMin, recMax, fieldName
  global gDBTitle, gDBResult
  dbBeginSession()
  set titles to []
  repeat with i = recMin to recMax
    DBGetRecord(i, "recipe")
    if gDBResult = 0 then
      set title to DBGetField(gDBTitle)
      if title <> EMPTY then
        add(titles, title & RETURN)
      end if
    end if
  end repeat
  DBEndSession()
  sort(titles)
  put listToString(titles) into field fieldName
end

on eventTypes
  global gDBResult, gDBTitle, gDBEvent1, gDBEvent2, gDBEvent3, gDBEvent4
  dbBeginSession()
  set events1 to []
  set events2 to []
  set events3 to []
  set events4 to []
  repeat with i = 1001 to 1453
    DBGetRecord(i, "recipe")
    if gDBResult = 0 then
      set title to DBGetField(gDBTitle) & RETURN
      set event1 to integer(DBGetField(gDBEvent1))
      if event1 then
        add(events1, title)
      end if
      set event2 to integer(DBGetField(gDBEvent2))
      if event2 then
        add(events2, title)
      end if
      set event3 to integer(DBGetField(gDBEvent3))
      if event3 then
        add(events3, title)
      end if
      set event4 to integer(DBGetField(gDBEvent4))
      if event4 then
        add(events4, title)
      end if
    end if
  end repeat
  sort(events1)
  sort(events2)
  sort(events3)
  sort(events4)
  put listToString(events1) into field "event type1"
  put listToString(events2) into field "event type2"
  put listToString(events3) into field "event type3"
  put listToString(events4) into field "event type4"
  DBEndSession()
end

on allTermDB
  global gDBTermID, gDBTermName, gDBResult, terms
  dbBeginSession()
  set terms to [:]
  DBGetRecord(1, "terms")
  if gDBResult = 0 then
    addProp(terms, DBGetField(gDBTermName), 1)
  end if
  repeat with i = 2 to 1046
    DBNextRecord("terms")
    if gDBResult = 0 then
      addProp(terms, DBGetField(gDBTermName), integer(DBGetField(gDBTermID)))
      next repeat
    end if
    put i
  end repeat
  DBEndSession()
  put terms into field "termIDDB"
end

on termsList
  global gDBResult, gDBTermName, terms
  set terms to []
  dbBeginSession()
  DBGetRecord(1, "terms")
  if gDBResult = 0 then
    add(terms, DBGetField(gDBTermName) & RETURN)
  end if
  repeat with i = 2 to 1046
    DBNextRecord("terms")
    if gDBResult = 0 then
      add(terms, DBGetField(gDBTermName) & RETURN)
      next repeat
    end if
    put i
  end repeat
  DBEndSession()
  sort(terms)
  put listToString(terms) into field "all terms"
end

on allFoodDB
  global gDBResult, gDBNutritionID, gDBNutritionFood, foods
  set foods to [:]
  dbBeginSession()
  DBGetRecord(1, "nutrition")
  if gDBResult = 0 then
    addProp(foods, DBGetField(gDBNutritionFood), integer(DBGetField(gDBNutritionID)))
  end if
  repeat with i = 2 to 478
    DBNextRecord("nutrition")
    if gDBResult = 0 then
      addProp(foods, DBGetField(gDBNutritionFood), integer(DBGetField(gDBNutritionID)))
      next repeat
    end if
    put i
  end repeat
  DBEndSession()
  put foods into field "foodIDDB"
end

on foodList
  global gDBResult, gDBNutritionFood, foods
  set foods to []
  dbBeginSession()
  DBGetRecord(1, "nutrition")
  if gDBResult = 0 then
    add(foods, DBGetField(gDBNutritionFood) & RETURN)
  end if
  repeat with i = 2 to 478
    DBNextRecord("nutrition")
    if gDBResult = 0 then
      add(foods, DBGetField(gDBNutritionFood) & RETURN)
      next repeat
    end if
    put i
  end repeat
  DBEndSession()
  sort(foods)
  put listToString(foods) into field "foods"
end

on allUtensilDB
  global gDBResult, gDBUtensilID, gDBUtensilName, utensils
  set utensils to [:]
  dbBeginSession()
  DBGetRecord(1, "utensil")
  if gDBResult = 0 then
    addProp(utensils, DBGetField(gDBUtensilName), integer(DBGetField(gDBUtensilID)))
  end if
  repeat with i = 2 to 64
    DBNextRecord("utensil")
    if gDBResult = 0 then
      addProp(utensils, DBGetField(gDBUtensilName), integer(DBGetField(gDBUtensilID)))
      next repeat
    end if
    put i
  end repeat
  DBEndSession()
  put utensils into field "utensilIDDB"
end

on utensilList
  global gDBResult, gDBUtensilName, utensils
  set utensils to []
  dbBeginSession()
  DBGetRecord(1, "utensil")
  if gDBResult = 0 then
    add(utensils, DBGetField(gDBUtensilName) & RETURN)
  end if
  repeat with i = 2 to 73
    DBNextRecord("utensil")
    if gDBResult = 0 then
      add(utensils, DBGetField(gDBUtensilName) & RETURN)
      next repeat
    end if
    put i
  end repeat
  DBEndSession()
  sort(utensils)
  put listToString(utensils) into field "utensils"
end

on allTableDB
  global gDBTableText, gDBResult, tables
  dbBeginSession()
  set tables to [:]
  set tablesList to []
  DBGetRecord(100001, "tables")
  if gDBResult = 0 then
    set table to DBGetField(gDBTableText)
    addProp(tables, table, 100001)
    add(tablesList, table & RETURN)
  end if
  set id to "100001"
  repeat with i = 11 to 53
    put i into char 1 to 2 of id
    set id to integer(id)
    DBGetRecord(id, "tables")
    if gDBResult = 0 then
      set table to DBGetField(gDBTableText)
      addProp(tables, table, id)
      add(tablesList, table & RETURN)
      next repeat
    end if
    put id
  end repeat
  DBEndSession()
  sort(tablesList)
  put listToString(tablesList) into field "tables"
  put tables into field "tableIDDB"
end

on makeIDDB fieldName
  set new to EMPTY
  set text to field fieldName
  set num to the number of lines in text
  repeat with i = 1 to num
    set it to line i of text
    put QUOTE & it & QUOTE & ":" && i & "," after new
  end repeat
  put "[" before new
  put "]" into char length(new) of new
  put new into field "IDDB"
end

on makeIDDB2 fieldName
  set new to EMPTY
  set text to field fieldName
  set num to the number of lines in text
  repeat with i = 1 to num
    set it to line i of text
    put i & ":" & QUOTE & it & QUOTE & ", " after new
  end repeat
  put "[" before new
  put "]" after new
  put new into field "IDDB"
end
